import { world, ItemStack, system, ItemUseBeforeEventSignal } from "@minecraft/server"
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui"

let rotation
let entity
const afd = new ActionFormData()



world.beforeEvents.itemUse.subscribe(eventData => {
    const item = eventData.itemStack.typeId
    const player = eventData.source
    if (item == "bony:structures") {
        main(player, afd)
    }
}
)

function main(player) {
    const afd = new ActionFormData()

    system.run(() => {
        afd.body("§ev3.0.0 \n§4§lWARNING§0§r: §fThere is no undo yet, make sure to backup your world.")
        afd.title("BY: §e§lBONY162 <-§l§4You§fTube§r")
        afd.button('Houses', 'textures/ui/store_home_icon.png')
        afd.button('Farms', 'textures/items/wheat.png')
        afd.button('Trees', 'textures/blocks/sapling_oak.png')
        afd.button('Random Structures', 'textures/ui/random_dice.png')
        afd.button('close', 'textures/ui/redX1.png')
        afd.show(player).then(({ selection }) => { // MAIN MENU
            switch (selection) {
                case 0:
                    House(player);
                    break;
                case 1:
                    Farm(player);
                    break;
                case 2:
                    Trees(player)
                    break
                case 3:
                    Random(player)
                    break
                case 4:
                    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§dMENU §cCLOSED."}]}`)
                    break;
            }
        })
    })
}

function House(player) {
    const hm = new ActionFormData()
    hm.title("§l§fHouse Styles")
    hm.button('Modern', 'textures/icons/mh_icon.png')
    hm.button('Medieval', 'textures/icons/md_icon.png')
    hm.button("Cherry Blossom")
    hm.button('§8[§cBack§8]', 'textures/ui/icon_import.png')
    hm.show(player).then(({ selection }) => {
        switch (selection) {
            case 0:
                Modern(player)
                break;
            case 1:
                Medieval(player);
                break;
            case 2:
                Cherry(player)
                break
            case 3:
                main(player);
                break;
        }
    });
}

function Farm(player) {
    const frm = new ModalFormData()
        .title("§l§fFarms")
        .dropdown("Farms 1-8 available", ['Iron Farm', 'Gold Farm', 'Pumpkin Farm', 'Melon Farm', 'Cactus Farm', 'Chicken Farm', 'Auto Smelter', 'Auto Cooker'])
        .dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)

    frm.show(player).then((response, canceled) => {
        switch (response.formValues[1]) {
            case 0:
                rotation = '0_degrees'
                break
            case 1:
                rotation = '90_degrees'
                break
            case 2:
                rotation = '180_degrees'
                break
            case 3:
                rotation = '270_degrees'
                break
        }
        if (canceled) return;
        switch (response.formValues[0]) {
            case 0:
                player.runCommandAsync(`structure load vf ~-10 ~-1 ~-15 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 1:
                player.runCommandAsync(`structure load gf ~-8 ~ ~3 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 2:
                player.runCommandAsync(`structure load Pf ~2 ~ ~-9 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 3:
                player.runCommandAsync(`structure load mf ~3 ~ ~-9 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 4:
                player.runCommandAsync(`structure load cts_farm ~3 ~-1 ~-9 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 5:
                player.runCommandAsync(`structure load chicken_farm ~2 ~ ~-1 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 6:
                player.runCommandAsync(`structure load auto_smelter ~-5 ~ ~-8 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 7:
                player.runCommandAsync(`structure load auto_cooker ~-5 ~ ~-8 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
        }
    })
};


function Modern(player) {
    const mdn = new ModalFormData()
        .title("§l§fModern Houses")
        .dropdown("Houses 1-26 available", ['Modern House 1', 'Modern House 2', 'Modern House 3', 'Modern House 4', 'Modern House 5', 'Modern House 6', 'Modern House 7', 'Modern House 8', 'Modern House 9', 'Modern House 10', 'Modern House 11', 'Modern House 12', 'Modern House 13', 'Modern House 14', 'Modern House 15', 'Modern House 16', 'Modern House 17', 'Modern House 18', 'Modern House 19', 'Modern House 20', 'Modern House 21', 'Modern House 22', 'Modern House 23', 'Modern House 24', 'Modern House 25', 'Modern House 26'])
        .dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)
    mdn.show(player).then((response) => {
        switch (response.formValues[1]) {
            case 0:
                rotation = '0_degrees'
                break
            case 1:
                rotation = '90_degrees'
                break
            case 2:
                rotation = '180_degrees'
                break
            case 3:
                rotation = '270_degrees'
                break
        }
        if (response.isCanceled) return;
        switch (response.formValues[0]) {
            case 0:
                player.runCommandAsync(`structure load mh_1 ~-7 ~ ~-12 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 1:
                player.runCommandAsync(`structure load mh_2 ~-15 ~-3 ~-36 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 2:
                player.runCommandAsync(`structure load mh_3 ~-20 ~-3 ~-43 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 3:
                player.runCommandAsync(`structure load mh_4 ~-20 ~-3 ~-33 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 4:
                player.runCommandAsync(`structure load mh_5 ~-20 ~-1 ~-39 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 5:
                player.runCommandAsync(`structure load mh_6 ~ ~-9 ~ ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 6:
                player.runCommandAsync(`structure load mh_7 ~-7 ~-2 ~-33 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 7:
                player.runCommandAsync(`structure load mh_8 ~-17 ~-1 ~-26 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 8:
                player.runCommandAsync(`structure load mh_9 ~-44 ~-2 ~ ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 9:
                player.runCommandAsync(`structure load mh_10 ~-12 ~-2 ~ ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 10:
                player.runCommandAsync(`structure load mh_11 ~-10 ~-2 ~1 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 11:
                player.runCommandAsync(`structure load mh_12 ~-17 ~-2 ~1 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 12:
                player.runCommandAsync(`structure load mh_13 ~-14 ~-2 ~-1 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 13:
                player.runCommandAsync(`structure load mh_14 ~-17 ~-2 ~-30 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 14:
                player.runCommandAsync(`structure load mh_15 ~-16 ~-2 ~-43 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 15:
                player.runCommandAsync(`structure load mh_16 ~-14 ~-2 ~ ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 16:
                player.runCommandAsync(`structure load mh_17 ~-21 ~-3 ~1 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 17:
                player.runCommandAsync(`structure load mh_18 ~-7 ~-1 ~-36 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 18:
                player.runCommandAsync(`structure load mh_19 ~-13 ~-3 ~-53 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 19:
                player.runCommandAsync(`structure load mh_20 ~-40 ~-2 ~ ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 20:
                player.runCommandAsync(`structure load mh_21 ~-14 ~-1 ~-29 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 21:
                player.runCommandAsync(`structure load mh_22 ~-12 ~-1 ~-33 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 22:
                player.runCommandAsync(`structure load mh_23 ~-8 ~-1 ~-20 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 23:
                player.runCommandAsync(`structure load mh_24 ~-17 ~-1 ~-25 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 24:
                player.runCommandAsync(`structure load mh_25 ~-16 ~-2 ~-24 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 25:
                player.runCommandAsync(`structure load mh_26 ~-8 ~-1 ~-25 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break

        }
    })
};

function Medieval(player) {
    const mdv = new ModalFormData()
        .title("§l§fMedieval Houses")
        .dropdown("Houses 1-20 available", ['Medieval 1', 'Medieval 2', 'Medieval 3', 'Medieval 4', 'Medieval 5', 'Medieval 6', 'Medieval 7', 'Medieval 8', 'Medieval 9', 'Medieval 10', 'Medieval 11', 'Medieval 12', 'Medieval 13', 'Medieval 14', 'Medieval 15', 'Medieval 16', 'Medieval 17', 'Medieval 18', 'Medieval 19', 'Medieval 20'])
        .dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)
    mdv.show(player).then((response, canceled) => {
        switch (response.formValues[1]) {
            case 0:
                rotation = '0_degrees'
                break
            case 1:
                rotation = '90_degrees'
                break
            case 2:
                rotation = '180_degrees'
                break
            case 3:
                rotation = '270_degrees'
                break
            default:
                afd(player);
                break;
        }
        if (canceled) return;
        switch (response.formValues[0]) {
            case 0:
                player.runCommandAsync(`structure load md_1 ~-10 ~-1 ~-30 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 1:
                player.runCommandAsync(`structure load md_2 ~-8 ~-1 ~-20 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 2:
                player.runCommandAsync(`structure load md_3 ~-12 ~-2 ~-17 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 3:
                player.runCommandAsync(`structure load md_4 ~-21 ~-1 ~-20 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 4:
                player.runCommandAsync(`structure load md_5 ~-11 ~-1 ~-24 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 5:
                player.runCommandAsync(`structure load md_6 ~-11 ~-1 ~4 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 6:
                player.runCommandAsync(`structure load md_7 ~-8 ~-1 ~-15 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 7:
                player.runCommandAsync(`structure load md_8 ~1 ~-3 ~-25 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 8:
                player.runCommandAsync(`structure load md_9 ~-19 ~ ~-11 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 9:
                player.runCommandAsync(`structure load md_10 ~-13 ~-3 ~-19 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 10:
                player.runCommandAsync(`structure load md_11 ~-18 ~-11 ~-30 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 11:
                player.runCommandAsync(`structure load md_12 ~-10 ~-2 ~-23 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 12:
                player.runCommandAsync(`structure load md_13 ~-13 ~-1 ~-20 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 13:
                player.runCommandAsync(`structure load md_14 ~-3 ~-1 ~-15 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 14:
                player.runCommandAsync(`structure load md_15 ~-7 ~-1 ~-15 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 15:
                player.runCommandAsync(`structure load md_16 ~-11 ~-1 ~-15 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 16:
                player.runCommandAsync(`structure load md_17 ~-8 ~-1 ~-22 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 17:
                player.runCommandAsync(`structure load md_18 ~-9 ~-1 ~-10 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 18:
                player.runCommandAsync(`structure load md_19 ~-16 ~-1 ~-25 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 19:
                player.runCommandAsync(`structure load md_20 ~-13 ~-1 ~-26 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
        }
    })
};

function Cherry(player) {
    const chr = new ModalFormData()
        .title("§l§fCherry Blossom Houses")
        .dropdown("Houses 1 available", ['Cherry Blossom 1', 'Cherry Blossom 2', 'Cherry Blossom 3'])
        .dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)
    chr.show(player).then((response, canceled) => {
        switch (response.formValues[1]) {
            case 0:
                rotation = '0_degrees'
                break
            case 1:
                rotation = '90_degrees'
                break
            case 2:
                rotation = '180_degrees'
                break
            case 3:
                rotation = '270_degrees'
                break
            default:
                afd(player);
                break;
        }
        if (canceled) return;
        switch (response.formValues[0]) {
            case 0:
                player.runCommandAsync(`structure load cb_0 ~ ~ ~-5 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 1:
                player.runCommandAsync(`structure load cb_1 ~-12 ~-1 ~-8 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 2:
                player.runCommandAsync(`structure load cb_2 ~-17 ~ ~-11 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            default:
                afd(player);
                break;
        }
    })
};

function Trees(player) {
    const trees = new ActionFormData()
    trees.title("Tree Type")
    trees.button("Regular", 'textures/icons/tree_icon.png')
    trees.button("Mushroom", 'textures/icons/mush_icon.png')
    trees.button("Other")
    trees.button('§8[§cBack§8]', 'textures/ui/icon_import.png')
    trees.show(player).then((response, canceled) => {
        if (response.isCanceled) return;
        switch (response.selection) {
            case 0:
                let tree = new ModalFormData();
                tree.title("Select your structure")
                tree.dropdown("Trees", ['Tree 1', 'Tree 2', 'Tree 3', 'Tree 4', 'Tree 5', 'Tree 6', 'Tree 7', 'Tree 8', 'Tree 9', 'Tree 10'])
                tree.dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)

                tree.show(player).then((response) => {
                    switch (response.formValues[1]) {
                        case 0:
                            rotation = '0_degrees'
                            break
                        case 1:
                            rotation = '90_degrees'
                            break
                        case 2:
                            rotation = '180_degrees'
                            break
                        case 3:
                            rotation = '270_degrees'
                            break
                    }
                    if (response.isCanceled) return;
                    switch (response.formValues[0]) {
                        case 0:
                            player.runCommandAsync(`structure load tree_01 ~ ~-1 ~ ${rotation}`)
                            break
                        case 1:
                            player.runCommandAsync(`structure load tree_02 ~ ~-1 ~ ${rotation}`)
                            break
                        case 2:
                            player.runCommandAsync(`structure load tree_03 ~ ~ ~ ${rotation}`)
                            break
                        case 3:
                            player.runCommandAsync(`structure load tree_04 ~ ~ ~ ${rotation}`)
                            break
                        case 4:
                            player.runCommandAsync(`structure load tree_05 ~ ~ ~ ${rotation}`)
                            break
                        case 5:
                            player.runCommandAsync(`structure load tree_06 ~ ~ ~ ${rotation}`)
                            break
                        case 6:
                            player.runCommandAsync(`structure load tree_07 ~ ~ ~ ${rotation}`)
                            break
                        case 7:
                            player.runCommandAsync(`structure load tree_08 ~ ~ ~ ${rotation}`)
                            break
                        case 8:
                            player.runCommandAsync(`structure load tree_09 ~ ~ ~ ${rotation}`)
                            break
                        case 9:
                            player.runCommandAsync(`structure load tree_10 ~ ~ ~ ${rotation}`)
                            break
                    }
                })
                break;
            case 1:
                let tree1 = new ModalFormData();
                tree1.title("Select your structure")
                tree1.dropdown("Trees", ['Mushroom 1', 'Mushroom 2', 'Mushroom 3', 'Mushroom 4', 'Mushroom 5', 'Mushroom 6', 'Mushroom 7', 'Mushroom 8', 'Mushroom 9'])
                tree1.dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)

                tree1.show(player).then((response) => {
                    switch (response.formValues[1]) {
                        case 0:
                            rotation = '0_degrees'
                            break
                        case 1:
                            rotation = '90_degrees'
                            break
                        case 2:
                            rotation = '180_degrees'
                            break
                        case 3:
                            rotation = '270_degrees'
                            break
                    }
                    if (response.isCanceled) return;
                    switch (response.formValues[0]) {
                        case 0:
                            player.runCommandAsync(`structure load tree_mr1 ~ ~-1 ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 1:
                            player.runCommandAsync(`structure load tree_mr2 ~ ~-1 ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 2:
                            player.runCommandAsync(`structure load tree_mr3 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 3:
                            player.runCommandAsync(`structure load tree_mr4 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 4:
                            player.runCommandAsync(`structure load tree_mr5 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 5:
                            player.runCommandAsync(`structure load tree_mr6 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 6:
                            player.runCommandAsync(`structure load tree_mr7 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 7:
                            player.runCommandAsync(`structure load tree_mr8 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 8:
                            player.runCommandAsync(`structure load tree_mr9 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                    }
                })
                break
            case 2:
                let otherTree = new ModalFormData();
                otherTree.title("Select your structure")
                otherTree.dropdown("Other Trees", ['Cactus 1', 'Cactus 2', 'Cactus 3', 'Cactus 4', 'Cactus 5', 'Oak Tree', 'Orange Tree', 'Pink Tree', 'White Tree'])
                otherTree.dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)

                otherTree.show(player).then((response) => {
                    switch (response.formValues[1]) {
                        case 0:
                            rotation = '0_degrees'
                            break
                        case 1:
                            rotation = '90_degrees'
                            break
                        case 2:
                            rotation = '180_degrees'
                            break
                        case 3:
                            rotation = '270_degrees'
                            break
                    }
                    if (response.isCanceled) return;
                    switch (response.formValues[0]) {
                        case 0:
                            player.runCommandAsync(`structure load tree_ct1 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 1:
                            player.runCommandAsync(`structure load tree_ct2 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 2:
                            player.runCommandAsync(`structure load tree_ct3 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 3:
                            player.runCommandAsync(`structure load tree_ct4 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 4:
                            player.runCommandAsync(`structure load tree_ct5 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 5:
                            player.runCommandAsync(`structure load tree_oak1 ~ ~ ~ ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 6:
                            player.runCommandAsync(`structure load tree_orange ~-8 ~ ~-13 ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 7:
                            player.runCommandAsync(`structure load tree_pink ~-8 ~ ~-13 ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                        case 8:
                            player.runCommandAsync(`structure load tree_white ~-8 ~ ~-13 ${rotation}`)
                            player.runCommandAsync(`playsound random.levelup @s ~~~`)
                            break
                    }
                })
                break;
            case 3:
                main(player)
                break
        }
    })

};

function Random(player) {
    let other = new ModalFormData();
    other.title("Select your structure")
    other.dropdown("Structures", ['Charmender', 'Chikorita', 'Blooper', 'cow'])
    other.dropdown("Rotation", ['0_degrees', '90_degrees', '180_degrees', '270_degrees'], 0)


    other.show(player).then((response) => {
        switch (response.formValues[1]) {
            case 0:
                rotation = '0_degrees'
                break
            case 1:
                rotation = '90_degrees'
                break
            case 2:
                rotation = '180_degrees'
                break
            case 3:
                rotation = '270_degrees'
                break
        }
        if (response.isCanceled) return;
        switch (response.formValues[0]) {
            case 0:
                player.runCommandAsync(`structure load rs_charmender ~-60 ~ ~-22 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 1:
                player.runCommandAsync(`structure load rs_chikorita ~-20 ~ ~-70 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 2:
                player.runCommandAsync(`structure load rs_blooper ~-24 ~ ~-20 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
            case 3:
                player.runCommandAsync(`structure load cow ~-9 ~ ~-3 ${rotation}`)
                player.runCommandAsync(`playsound random.levelup @s ~~~`)
                break
        }
    })
}
